/*************************************************  Common Functions Header  **************************************************

	Red Rapids
	797 N Grove Rd
	Suite 101
	Richardson, TX 75081
	www.redrapids.com | support@redrapids.com

	Copyright (c) 2019  Red Rapids, Inc.

	Permission is hereby granted, free of charge, to any person obtaining a copy of this software and associated documentation
	files (the "Software"), to deal in the Software without restriction, including without limitation the rights to use, copy,
	modify, merge, publish, distribute, sublicense, and/or sell copies of the Software, and to permit persons to whom the Software
	is furnished to do so, subject to the following conditions:

	The above copyright notice and this permission notice shall be included in all copies or substantial portions of the Software.

	THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES
	OF MERCHANTABILITY, FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE AUTHORS OR COPYRIGHT HOLDERS BE
	LIABLE FOR ANY CLAIM, DAMAGES OR OTHER LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM, OUT OF OR
	IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN THE SOFTWARE.

*************************************************  Common Functions Header  **************************************************/

#ifndef _PROGRAMMER_FUNCTIONS_H_
#define _PROGRAMMER_FUNCTIONS_H_

#if defined(__cplusplus)
	extern "C" {
#endif

typedef	struct s_FlashCode
{
	unsigned address;
	unsigned data;
	struct s_FlashCode *next;
} s_FlashCode;

// Prototypes for each of the common functions in alphabetic order.
unsigned HexToUnsigned(char *HexNumber);
int BlankCheck(s_Handle *p_HW, unsigned AddressStart, unsigned AddressEnd);
unsigned DeviceID(s_Handle *p_HW);
int Erase(s_Handle *p_HW, unsigned AddressStart, unsigned AddressEnd);
int FreeResources(s_Handle *p_HW, s_UIOScan UIO, s_FlashCode *p_FlashCode);
unsigned GetClockStatus(s_Handle *p_HW);
unsigned MCSCount(s_FlashCode *p_FlashCode);
s_FlashCode* MCSParser(char *MCSFileName);
int Program(s_Handle *p_HW, s_FlashCode *p_FlashCode);
void Progress(unsigned JobSize, unsigned *JobCounter, unsigned *PercentComplete, unsigned Percentage);
void ProgAddress(s_Handle *p_HW, unsigned Address);
void ProgDisable(s_Handle *p_HW);
void ProgEnable(s_Handle *p_HW);
void ProgInit(s_Handle *p_HW);
void ProgRead(s_Handle *p_HW, unsigned *p_Value);
void ProgSegment(s_Handle *p_HW, unsigned Revision);
void ProgWait(s_Handle *p_HW);
void ProgWrite(s_Handle *p_HW, unsigned Command);
void ReadID(s_Handle *p_HW, unsigned Address, unsigned Offset, unsigned *p_Value);
int StatusCheck(s_Handle *p_HW, unsigned Address, unsigned Timer);
void StatusClear(s_Handle *p_HW, unsigned Address);
void StatusRead(s_Handle *p_HW, unsigned Address, unsigned *p_Value);
int Unlock(s_Handle *p_HW, unsigned AddressStart, unsigned AddressEnd);
int Verify(s_Handle *p_HW, s_FlashCode *p_FlashCode);

#ifdef __cplusplus
}
#endif

#endif
