/**************************************************  DMA Functions Header  ***************************************************

	Red Rapids
	797 N Grove Rd
	Suite 101
	Richardson, TX 75081
	www.redrapids.com | support@redrapids.com

	Copyright (c) 2019  Red Rapids, Inc.

	Permission is hereby granted, free of charge, to any person obtaining a copy of this software and associated documentation
	files (the "Software"), to deal in the Software without restriction, including without limitation the rights to use, copy,
	modify, merge, publish, distribute, sublicense, and/or sell copies of the Software, and to permit persons to whom the Software
	is furnished to do so, subject to the following conditions:

	The above copyright notice and this permission notice shall be included in all copies or substantial portions of the Software.

	THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES
	OF MERCHANTABILITY, FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE AUTHORS OR COPYRIGHT HOLDERS BE
	LIABLE FOR ANY CLAIM, DAMAGES OR OTHER LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM, OUT OF OR
	IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN THE SOFTWARE.

**************************************************  DMA Functions Header  ***************************************************/

#ifndef _DMA_FUNCTIONS_H_
#define _DMA_FUNCTIONS_H_

#if defined(__cplusplus)
	extern "C" {
#endif

// Structure to store the results returned by a DMA status query to the device.
typedef struct
{
	unsigned CurrentPage;
	unsigned CurrentBurst;
	unsigned Engine[3];
} s_DMAStatus;

// Prototypes for each of the DMA functions.
void DMAAssign(s_Handle *p_HW, unsigned BufferIndex);
int DMAConfigCheck(s_DMABuf DMA, unsigned *ConfigError);
int DMALoad(char *p_File, s_DMABuf *DMA, unsigned DataItemSize);
int DMASave(char *p_File, s_DMABuf *DMA, s_Channel RXChannel, s_TODSettings TODClock, unsigned NumPages, unsigned PacketInfo);
void DMAStatus(s_Handle *p_HW, unsigned ChannelNumber, s_DMAStatus *p_DMA);

#ifdef __cplusplus
}
#endif

#endif
