/*************************************************  Product Functions Header  **************************************************

	Red Rapids
	797 N Grove Rd
	Suite 101
	Richardson, TX 75081
	www.redrapids.com | support@redrapids.com

	Copyright (c) 2019  Red Rapids, Inc.

	Permission is hereby granted, free of charge, to any person obtaining a copy of this software and associated documentation
	files (the "Software"), to deal in the Software without restriction, including without limitation the rights to use, copy,
	modify, merge, publish, distribute, sublicense, and/or sell copies of the Software, and to permit persons to whom the Software
	is furnished to do so, subject to the following conditions:

	The above copyright notice and this permission notice shall be included in all copies or substantial portions of the Software.

	THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES
	OF MERCHANTABILITY, FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE AUTHORS OR COPYRIGHT HOLDERS BE
	LIABLE FOR ANY CLAIM, DAMAGES OR OTHER LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM, OUT OF OR
	IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN THE SOFTWARE.

*************************************************  Product Functions Header  **************************************************/

#ifndef _PRODUCT_FUNCTIONS_H_
#define _PRODUCT_FUNCTIONS_H_

#if defined(__cplusplus)
	extern "C" {
#endif

// Structure to reference all of the device configuration settings for a Model 271.
typedef struct
{
	s_AD9512 ClockDist;
	s_ADS42LB69 RX1TO2_ADC;
	s_LTC1661 RX1_TRIM_DAC;
	s_LTC1661 RX2_TRIM_DAC;
	s_ADL5566 RX1TO2_AMP_ENBL;
	s_ADF4110 Synthesizer;
} s_M271Devices;

// Structure to reference all of the device configuration settings for a Model 273.
typedef struct
{
	s_LMK01000 ClockDist;
	s_AD9652 RX1TO2_ADC;
	s_LTC1661 RX1_TRIM_DAC;
	s_LTC1661 RX2_TRIM_DAC;
	s_ADA4927 RX1_AMP_ENBL;
	s_ADA4927 RX2_AMP_ENBL;
	s_PROGSYNTH PROG_SYNTH;
} s_M273Devices;

// Structure to reference all of the device configuration settings for a Model 276.
typedef struct
{
	s_ADC12D1600 RX1TO2_ADC;
	s_LTC1661 RX1_TRIM_DAC;
	s_LTC1661 RX2_TRIM_DAC;
	s_ADL5566 RX1TO2_AMP_ENBL;
} s_M276Devices;

// Structure to reference all of the device configuration settings for a Model 277.
typedef struct
{
	s_AD9512 ClockDist;
	s_ADS42LB69 RX1TO2_ADC;
	s_ADS42LB69 RX3TO4_ADC;
	s_LTC1661 RX1_TRIM_DAC;
	s_LTC1661 RX2_TRIM_DAC;
	s_LTC1661 RX3_TRIM_DAC;
	s_LTC1661 RX4_TRIM_DAC;
	s_ADL5566 RX1TO2_AMP_ENBL;
	s_ADL5566 RX3TO4_AMP_ENBL;
	s_ADF4110 Synthesizer;
} s_M277Devices;

// Prototypes for each of the device functions.
int HWInitialize(s_Handle *p_HW, unsigned Model);
int M271Initialize(s_Handle *p_HW, s_M271Devices M271Devices);
int M273Initialize(s_Handle *p_HW, s_M273Devices M273Devices);
int M276Initialize(s_Handle *p_HW, s_M276Devices M276Devices);
int M277Initialize(s_Handle *p_HW, s_M277Devices M277Devices);

#ifdef __cplusplus
}
#endif

#endif
